///home/berryj/link/bin/genMethods "-g" "-t" "MBinGraph*" "-r" "MHyperGraph*" "-I" "LINK/graph/HyperGraph.h" "-I" "LINK/graph/BinGraph.h" "-y" "display_graphptr" "-m" "mark_graphptr" "-w" "free_graphptr" "-d" "graph" "-f" "___mBinGraph_" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/HyperGraph.h>

#include <LINK/graph/BinGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graphptr(SCM, SCM, int);
void mark_graphptr(SCM);
void free_graphptr(SCM);

typedef MBinGraph* _MBinGraph_;

#define _MBinGraph_DATA(x) ((MBinGraph**) (EXTDATA(x)))
#define _MBinGraph_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MBinGraph* >::type))
#define _MBinGraph_ISNT_DATA(x) (!_MBinGraph_IS_DATA(x))

#define _MBinGraph_CXX_DATA(x) (*(MBinGraph**) (EXTDATA(VAL(x))))
#define _MBinGraph_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MBinGraph* >::type))
#define _MBinGraph_CXX_ISNT_DATA(x) (!_MBinGraph_CXX_IS_DATA(x))


static SCM is_MBinGraph_(SCM i)
{
	if (_MBinGraph_CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init____mBinGraph_()
{
	Wrapper<_MBinGraph_>::type = STk_new_CXXwrapper_id(
			Wrapper<_MBinGraph_>::name, 
			Wrapper<MHyperGraph* >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graphptr,
			(void (*)(SCM x))mark_graphptr,
			(void (*)(SCM x))free_graphptr);
	Tcl_InitHashTable(&Register<_MBinGraph_>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("MBinGraph?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_MBinGraph_);
	return UNDEFINED;
}

void genExtra___mBinGraph_Methods(void);

PRIMITIVE STk_init_methods____mBinGraph_()
{
	genExtra___mBinGraph_Methods();
	return UNDEFINED;
}
